#!/bin/bash

#assumes 
# input:  _latitude  in [ -90;  90]
# input:  _longitude in [-180; 180]
# output: _color

dbroweval '
   use POSIX qw(fmod);
   sub hsl2rgb {
       my ($h,$s,$l) = @_;
       my $c  =(1. - abs(2*$l-1))*$s;
       my $hh = $h/60.;
       my $x  = $c*(1. - abs($hh - 2*int($hh/2.) - 1.));
       my @rgb;
       @rgb = ($c, $x, 0)
               if 0<=$hh && $hh<1;
       @rgb = ($x, $c, 0)
               if 1<=$hh && $hh<2;
       @rgb = (0, $c, $x)
               if 2<=$hh && $hh<3;
       @rgb = (0, $x, $c)
               if 3<=$hh && $hh<4;
       @rgb = ($x, 0, $c)
               if 4<=$hh && $hh<5;
       @rgb = ($c, 0, $x)
               if 5<=$hh && $hh<6;
       my $m = $l-$c/2.;
       @rgb = map { $_ = int(255*($_+$m)) } @rgb;
       return @rgb;
   }
   my ($lon, $lat) =  (_longitude, _latitude);
   if ($lon ne "-" && $lat ne "-") {
	   $lat = -$lat;
	   $lon = fmod($lon+3600, 360);
	   my ($LATL, $LATH) = (-115, 80);
	   $lat = $LATH if $lat > $LATH;
	   $lat = $LATL if $lat < $LATL;
	   my @rgb = hsl2rgb($lon, 1, ($lat - $LATL)/($LATH-$LATL));
	   _color = sprintf("%02x%02x%02x", @rgb);
   } else {
       _color = "-";
   }
'
